unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, IniFiles,
  Dialogs, StdCtrls, ExtCtrls, Buttons, Shellapi;

type
  TMainForm = class(TForm)
    Bevel1: TBevel;
    Bevel2: TBevel;
    Persistente: TCheckBox;
    Label1: TLabel;
    Button1: TBitBtn;
    Button2: TBitBtn;
    Button3: TBitBtn;
    Button4: TBitBtn;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Bevel5: TBevel;
    Bevel6: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Button4Click(Sender: TObject);
    procedure LeggiIni;
    procedure LanciaProgramma (NomeProgramma, NomeFile: string);

  private
    { Private declarations }
    Programma1: String;
    Programma2: String;
    Programma3: String;
    Programma4: String;
    Estensione: String;
    NomeFile:   String;

  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses Unit2;{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  if ParamCount = 0 then
  begin
    Application.CreateForm(TMain, Main);
    Main.Show;
    exit;
  end;

  chdir (ExtractFilePath(ParamStr(1)));
  Estensione := ExtractFileExt(ParamStr(1));
  NomeFile := ExtractFileName(ParamStr(1));
  Caption := 'Open  "' + NomeFile + '"  with...';

  if FileExists(UpperCase(ExtractfilePath(application.exename)) + 'APRI.INI') then
    LeggiIni
  else
  begin
    MessageDlg('File INI non trovato', mtError, [mbOK], 0);
    Application.Terminate;
    exit;
  end;
end;

procedure TMainForm.LeggiIni;
var
  ApriFile: Tinifile;
  Punt    : THandle;
begin
  ApriFile := TIniFile.Create(UpperCase(ExtractfilePath(application.exename)) + 'APRI.INI');

  Programma1 := ApriFile.ReadString(Estensione, 'Primo', '');
  Programma2 := ApriFile.ReadString(Estensione, 'Secondo', '');
  Programma3 := ApriFile.ReadString(Estensione, 'Terzo', '');
  Programma4 := ApriFile.ReadString(Estensione, 'Quarto', '');

  if Programma1 = '' then Button1.Enabled := False
  else begin
      Punt := ExtractIcon(Self.Handle, PChar(Programma1), 0);
      MainForm.Image1.Picture.Icon.Handle := Punt;
	  MainForm.Button1.Caption := ApriFile.ReadString(Estensione, 'PrimoNome', '');
  end;
  if Programma2 = '' then Button2.Enabled := False
  else begin
      Punt := ExtractIcon(Self.Handle, PChar(Programma2), 0);
      MainForm.Image2.Picture.Icon.Handle := Punt;
      MainForm.Button2.Caption := ApriFile.ReadString(Estensione, 'SecondoNome', '');
  end;

  if Programma3 = '' then Button3.Enabled := False
  else begin
      Punt := ExtractIcon(Self.Handle, PChar(Programma3), 0);
      MainForm.Image3.Picture.Icon.Handle := Punt;
      MainForm.Button3.Caption := ApriFile.ReadString(Estensione, 'TerzoNome', '');
  end;

  if Programma4 = '' then Button4.Enabled := False
  else begin
      Punt := ExtractIcon(Self.Handle, PChar(Programma4), 0);
      MainForm.Image4.Picture.Icon.Handle := Punt;
      MainForm.Button4.Caption := ApriFile.ReadString(Estensione, 'QuartoNome', '');
  end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  if Programma1 = '' then exit;
  try
     LanciaProgramma(Programma1, ParamStr(1));
     if not Persistente.Checked then
        Application.Terminate;
  except
     Application.Terminate;
  end;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  if Programma2 = '' then exit;
  try
     LanciaProgramma(Programma2, ParamStr(1));
     if not Persistente.Checked then
        Application.Terminate;
  except
     Application.Terminate;
  end;
end;

procedure TMainForm.Button3Click(Sender: TObject);
begin
   if Programma3 = '' then exit;
   try
      LanciaProgramma(Programma3, ParamStr(1));
      if not Persistente.Checked then
         Application.Terminate;
   except
      Application.Terminate;
   end;
end;

procedure TMainForm.Button4Click(Sender: TObject);
begin
   if Programma4 = '' then exit;
   try
      LanciaProgramma(Programma4, ParamStr(1));
      if not Persistente.Checked then
         Application.Terminate;
   except
      Application.Terminate;
   end;
end;

procedure TMainForm.LanciaProgramma(NomeProgramma, NomeFile: string);
begin
   WinExec (PChar('"' + NomeProgramma + '"  "' + NomeFile + '"'), SW_SHOW);
end;

procedure TMainForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
   if Key = #27 then Application.Terminate;
end;

end.
